Bug 1466739 - (CVE-2017-9227) CVE-2017-9227 oniguruma: Out-of-bounds stack read in mbc_enc_len() during regular expression searching
CVE-2017-9227 oniguruma: Out-of-bounds stack read in mbc_enc_len() during reg...
Status: NEW
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
medium Severity medium
: ---
: ---
Assigned To: Red Hat Product Security
impact=moderate,public=20170523,repor...
: Security
Depends On: 1466750 1466753 1466749 1466751 1466752 1554537
Blocks: 1466748
  Show dependency treegraph
 
Reported: 2017-06-30 07:06 EDT by Adam Mariš
Modified: 2018-05-03 01:07 EDT (History)
41 users (show)

See Also:
Fixed In Version: oniguruma 6.3.0, php 5.6.31, php 7.0.21, php 7.1.7
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2018:1296 None None None 2018-05-03 01:07 EDT

  None (edit)
Description Adam Mariš 2017-06-30 07:06:19 EDT
An issue was discovered in Oniguruma 6.2.0, as used in Oniguruma-mod in
Ruby through 2.4.1 and mbstring in PHP through 7.1.5. A stack
out-of-bounds read occurs in mbc_enc_len() during regular expression
searching. Invalid handling of reg->dmin in forward_search_range()
could result in an invalid pointer dereference, as an out-of-bounds
read from a stack buffer.
 
Upstream bug:

https://github.com/kkos/oniguruma/issues/58

Upstream patch:

https://github.com/kkos/oniguruma/commit/9690d3ab1f9bcd2db8cbe1fe3ee4a5da606b8814
Comment 1 Adam Mariš 2017-06-30 07:33:27 EDT
Created oniguruma tracking bugs for this issue:

Affects: epel-7 [bug 1466750]
Affects: fedora-all [bug 1466752]


Created php tracking bugs for this issue:

Affects: fedora-all [bug 1466751]


Created ruby tracking bugs for this issue:

Affects: fedora-all [bug 1466749]


Created ruby193-ruby tracking bugs for this issue:

Affects: openshift-1 [bug 1466753]
Comment 2 Dominik Mierzejewski 2017-09-05 06:03:49 EDT
How is ruby affected? Was this reported to ruby developers?
Comment 3 Vít Ondruch 2017-09-05 06:25:36 EDT
Yes, it was.

This is the short answer:

~~~
I don't think the CVEs directly apply to us.  See below.  In short, We
check validity of strings before matching.
~~~

And for this specific issue, this is the long version:

~~~
> CVE-2017-9227 https://github.com/kkos/oniguruma/issues/58

not affected.

% ruby <<'END'
str   = [ 0xc7, 0xd6, 0xfe, 0xea, 0xe0, 0xe2, 0x00 ].pack('c*')
input = [0x6a, 0x00, 0x01, 0x6c, 0x7b, 0x00, 0x01, 0x6c, 0x7b, 0x32,
        0x32, 0x7d, 0x7b, 0x32, 0x32, 0x7d, 0x7b, 0x32, 0x32, 0x7d,
        0x7b, 0x32, 0x32, 0x7d, 0x7b, 0x32, 0x32, 0x7d, 0x7b, 0x32,
        0x32, 0x7d, 0x7b, 0x32, 0x32, 0x7d, 0x7b, 0x32, 0x32, 0x6a,
        0x00, 0x01, 0x6c, 0x7b, 0x1d, 0x1d, 0x1d, 0x1d, 0x1d, 0x1d,
        0x1d, 0x1d, 0x1d, 0x1d, 0x1d, 0x1d, 0x1d, 0x1d, 0x1d, 0x1d,
        0x1d, 0x1d, 0x32, 0x32, 0x7d, 0x7b, 0x32, 0x32, 0x7d, 0x7b,
        0x32, 0x32, 0x7d, 0x7b, 0x32, 0x32, 0x7d, 0x7b, 0x32, 0x32,
        0x7d, 0x7b, 0x32, 0x7d, 0x7b, 0x32, 0x32, 0x7d, 0x7b, 0x32,
        0x32, 0x7d, 0x7b, 0x32, 0x7d].pack('c*')

re = Regexp.new(input.force_encoding('UTF-8'), Regexp::IGNORECASE)
re.match str.force_encoding('UTF-8')
END
Traceback (most recent call last):
        1: from -:14:in `<main>'
-:14:in `match': invalid byte sequence in UTF-8 (ArgumentError)
~~~

But they are still awaiting for upstream (Oniguruma) response.
Comment 4 Dominik Mierzejewski 2017-09-05 06:47:59 EDT
Thank you for the clarification, Vit. Could you please have the advisory at https://access.redhat.com/security/cve/CVE-2017-9227 updated to say that ruby is not affected, then?
Comment 5 Vít Ondruch 2017-09-05 06:56:06 EDT
(In reply to Dominik Mierzejewski from comment #4)
Unfortunately, this is not in my hands. This should be:

1) Officially clarified by upstream.
2) The portal should be updated by Red Hat Security team.
Comment 6 Doran Moppert 2017-09-06 22:55:28 EDT
Thanks Vit!

Ruby's string validation blocks the obvious reproducer, but I wasn't confident enough that other paths couldn't reach it to mark Ruby as notaffected.

If you receive further info from upstream, please needinfo or mail me directly and I'll make sure these bugs and the CVE pages are updated correctly.
Comment 9 errata-xmlrpc 2018-05-03 01:06:54 EDT
This issue has been addressed in the following products:

  Red Hat Software Collections for Red Hat Enterprise Linux 6
  Red Hat Software Collections for Red Hat Enterprise Linux 6.7 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7
  Red Hat Software Collections for Red Hat Enterprise Linux 7.3 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.4 EUS
  Red Hat Software Collections for Red Hat Enterprise Linux 7.5 EUS

Via RHSA-2018:1296 https://access.redhat.com/errata/RHSA-2018:1296

Note You need to log in before you can comment on or make changes to this bug.